#pragma once
#include <PSX/System/threads.hpp>

namespace JabyEngine {
    namespace Callback {
        namespace internal {
            static void execute_thread(SysCall::ThreadHandle thread_handle) {
                MainThread::prepare_if_main(thread_handle);
                Thread::execute_next();    
            }

            namespace VSync {
                static constexpr size_t StackSize = 64;

                extern SysCall::ThreadHandle thread_handle;
                extern uint32_t              stack[StackSize];
                void                         routine();

                static void [[deprecated("Currently not in use")]] execute() {
                    execute_thread(VSync::thread_handle);
                }
            }

            namespace CD {
                static constexpr size_t StackSize = 256;

                extern SysCall::ThreadHandle thread_handle;
                extern uint32_t              stack[StackSize];

                static void execute() {
                    execute_thread(CD::thread_handle);
                }
            }
        }
    }
}
